# coding: utf-8

"""
    URL Shortener API

    This API is responsible of authetication and the creation, modification and deletion of uris and hooks.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class UriApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def activate_uri(self, uri_id, **kwargs):  # noqa: E501
        """Activate a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.activate_uri(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to activate (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.activate_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
        else:
            (data) = self.activate_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
            return data

    def activate_uri_with_http_info(self, uri_id, **kwargs):  # noqa: E501
        """Activate a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.activate_uri_with_http_info(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to activate (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uri_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method activate_uri" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uri_id' is set
        if ('uri_id' not in params or
                params['uri_id'] is None):
            raise ValueError("Missing the required parameter `uri_id` when calling `activate_uri`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uri_id' in params:
            path_params['uriId'] = params['uri_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/uris/{uriId}/activate', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='URI',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_uri(self, body, **kwargs):  # noqa: E501
        """Add a new URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_uri(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param URIRequest body: URI that needs to be created (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_uri_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.add_uri_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def add_uri_with_http_info(self, body, **kwargs):  # noqa: E501
        """Add a new URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_uri_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param URIRequest body: URI that needs to be created (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_uri" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_uri`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/uris', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='URI',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def deactivate_uri(self, uri_id, **kwargs):  # noqa: E501
        """Deactivate a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.deactivate_uri(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to deactivate (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.deactivate_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
        else:
            (data) = self.deactivate_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
            return data

    def deactivate_uri_with_http_info(self, uri_id, **kwargs):  # noqa: E501
        """Deactivate a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.deactivate_uri_with_http_info(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to deactivate (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uri_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method deactivate_uri" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uri_id' is set
        if ('uri_id' not in params or
                params['uri_id'] is None):
            raise ValueError("Missing the required parameter `uri_id` when calling `deactivate_uri`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uri_id' in params:
            path_params['uriId'] = params['uri_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/uris/{uriId}/deactivate', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='URI',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_uri(self, uri_id, **kwargs):  # noqa: E501
        """Deletes a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_uri(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: URI id to delete (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
            return data

    def delete_uri_with_http_info(self, uri_id, **kwargs):  # noqa: E501
        """Deletes a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_uri_with_http_info(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: URI id to delete (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uri_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_uri" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uri_id' is set
        if ('uri_id' not in params or
                params['uri_id'] is None):
            raise ValueError("Missing the required parameter `uri_id` when calling `delete_uri`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uri_id' in params:
            path_params['uriId'] = params['uri_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/uris/{uriId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_hooks_by_uri(self, uri_id, **kwargs):  # noqa: E501
        """Retrieves all the hooks of a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_hooks_by_uri(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to get hooks from (required)
        :return: list[Hook]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_hooks_by_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_hooks_by_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
            return data

    def get_hooks_by_uri_with_http_info(self, uri_id, **kwargs):  # noqa: E501
        """Retrieves all the hooks of a URI  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_hooks_by_uri_with_http_info(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to get hooks from (required)
        :return: list[Hook]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uri_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_hooks_by_uri" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uri_id' is set
        if ('uri_id' not in params or
                params['uri_id'] is None):
            raise ValueError("Missing the required parameter `uri_id` when calling `get_hooks_by_uri`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uri_id' in params:
            path_params['uriId'] = params['uri_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/uris/{uriId}/hooks', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Hook]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_uri(self, uri_id, **kwargs):  # noqa: E501
        """Find URI by ID  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_uri(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to return (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_uri_with_http_info(uri_id, **kwargs)  # noqa: E501
            return data

    def get_uri_with_http_info(self, uri_id, **kwargs):  # noqa: E501
        """Find URI by ID  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_uri_with_http_info(uri_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uri_id: ID of URI to return (required)
        :return: URI
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uri_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_uri" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uri_id' is set
        if ('uri_id' not in params or
                params['uri_id'] is None):
            raise ValueError("Missing the required parameter `uri_id` when calling `get_uri`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uri_id' in params:
            path_params['uriId'] = params['uri_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/uris/{uriId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='URI',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_uri_by_user(self, user_id, **kwargs):  # noqa: E501
        """Retrieves all the URI of a user  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_uri_by_user(user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int user_id: ID of user to get URI from (required)
        :return: list[URI]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_uri_by_user_with_http_info(user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_uri_by_user_with_http_info(user_id, **kwargs)  # noqa: E501
            return data

    def get_uri_by_user_with_http_info(self, user_id, **kwargs):  # noqa: E501
        """Retrieves all the URI of a user  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_uri_by_user_with_http_info(user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int user_id: ID of user to get URI from (required)
        :return: list[URI]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_uri_by_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user_id' is set
        if ('user_id' not in params or
                params['user_id'] is None):
            raise ValueError("Missing the required parameter `user_id` when calling `get_uri_by_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user_id' in params:
            path_params['userId'] = params['user_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/users/{userId}/uris', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[URI]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
